program convert;

uses dos,crt;

var  data:text;
     tempnum:byte;
     errcode:integer;
     tempstr:string;

function FileExists(FName: STRING): Boolean;
  Var TFile: TEXT;
      S: String;
  Begin
    s := FSEARCH(FNAME, '');
    FileExists := S <> '';
  end;


procedure convert2ans;
 var data2:text;
     s,f,g,h:string;
     x,q,d:byte;
  begin
    IF paramstr(3) = '' then begin
       textcolor(15);
       writeln;
     writeln('Syntax:  LORDCONV <input> # <output>');
     writeln;
     writeln('     <input> - full path and filename of input file');
     writeln('               (ex. C:\LORD\LOGNOW.TXT)');
     writeln;
     writeln('           # - Color Output Option');
     writeln('               (1 - Renegade or Pipe-based system)');
     writeln('               (2 - ANsI)');
     writeln('               (3 - ASCII)');
     writeln('               (4 - Other - Read docs!)');
     writeln;
     writeln('    <output> - full path and filename of input file');
     writeln('               (ex. C:\BBS\BULLS\BULL1.ANS)');

     writeln;
     close(data);
     halt;
    end;
    assign(data2,paramstr(3));
    rewrite(data2);
    x := 0;
    repeat
    x := 0;
    tempstr := '';
    readln(data,tempstr);
    s := tempstr;
    tempstr := '';
    repeat
    IF (POS('`',s) > 0) then begin
      IF (s[pos('`',s)+1]) IN ['1','2','3','4','5','6','7','8','9','0','!','@','#','$','%','.'] then begin
       g := '';
       for q := 1 to (POS('`',s)-1) do g := g + s[q];
       CASE s[POS('`',s)+1] of
       '%':h := '[0;1m';
       '1':h := '[0;34m';
       '2':h := '[0;32m';
       '3':h := '[0;36m';
       '4':h := '[0;31m';
       '5':h := '[0;35m';
       '6':h := '[0;33m';
       '7':h := '[0m';
       '8':h := '[0;1;30m';
       '9':h := '[0;1;34m';
       '0':h := '[0;1;32m';
       '!':h := '[0;1;36m';
       '@':h := '[0;1;31m';
       '#':h := '[0;1;35m';
       '$':h := '[0;1;33m';
       '.':h := '';
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       tempstr := tempstr+g+h;
       x := LENGTH(g);
       s := f;
       end
       else begin
       h := '';
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       tempstr := tempstr+g+h;
       x := length(g);
       s := f;
       end;
      end;
   until (POS('`',s ) = 0);
   tempstr := tempstr + f;
   writeln(data2,tempstr);
   until eof(data);
   close(data2);
  end;



procedure convert2other;
 var data2:text;
     temp:array[1..15] of string[10];
     s,f,g,h:string;
     x,q,d:byte;
  begin
    IF paramstr(3) = '' then begin
       textcolor(15);
       writeln;
     writeln('Syntax:  LORDCONV <input> # <output>');
     writeln;
     writeln('     <input> - full path and filename of input file');
     writeln('               (ex. C:\LORD\LOGNOW.TXT)');
     writeln;
     writeln('           # - Color Output Option');
     writeln('               (1 - Renegade or Pipe-based system)');
     writeln('               (2 - ANsI)');
     writeln('               (3 - ASCII)');
     writeln('               (4 - Other - Read docs!)');
     writeln;
     writeln('    <output> - full path and filename of input file');
     writeln('               (ex. C:\BBS\BULLS\BULL1.ANS)');

     writeln;
     close(data);
     halt;
    end;
    assign(data2,'other.cfg');
    reset(data2);
    for d := 1 to 15 do readln(data2,temp[d]);
    close(data2);
    assign(data2,paramstr(3));
    rewrite(data2);
    x := 0;
    repeat
    x := 0;
    tempstr := '';
    readln(data,tempstr);
    s := tempstr;
    tempstr := '';
    repeat
    IF (POS('`',s) > 0) then begin
      IF (s[pos('`',s)+1]) IN ['1','2','3','4','5','6','7','8','9','0','!','@','#','$','%','.'] then begin
       g := '';
       for q := 1 to (POS('`',s)-1) do g := g + s[q];
       CASE s[POS('`',s)+1] of
       '1':h := temp[1];
       '2':h := temp[2];
       '3':h := temp[3];
       '4':h := temp[4];
       '5':h := temp[5];
       '6':h := temp[6];
       '7':h := temp[7];
       '8':h := temp[8];
       '9':h := temp[9];
       '0':h := temp[10];
       '!':h := temp[11];
       '@':h := temp[12];
       '#':h := temp[13];
       '$':h := temp[14];
       '%':h := temp[15];
       '.':h := '';
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       tempstr := tempstr+g+h;
       x := LENGTH(g);
       s := f;
       end
       else begin
       f := '';
       h := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       tempstr := tempstr+g+h;
       x := length(g);
       s := f;
       end;
      end;
   until (POS('`',s ) = 0);
   tempstr := tempstr + f;
   writeln(data2,tempstr);
   until eof(data);
   close(data2);
  end;


procedure convert2asc;
 var data2:text;
     s,f,g,h:string;
     x,q,d:byte;
  begin
    IF paramstr(3) = '' then begin
       textcolor(15);
       writeln;
     writeln('Syntax:  LORDCONV <input> # <output>');
     writeln;
     writeln('     <input> - full path and filename of input file');
     writeln('               (ex. C:\LORD\LOGNOW.TXT)');
     writeln;
     writeln('           # - Color Output Option');
     writeln('               (1 - Renegade or Pipe-based system)');
     writeln('               (2 - ANsI)');
     writeln('               (3 - ASCII)');
     writeln('               (4 - Other - Read docs!)');
     writeln;
     writeln('    <output> - full path and filename of input file');
     writeln('               (ex. C:\BBS\BULLS\BULL1.ANS)');
     writeln;
     close(data);
     halt;
    end;
    assign(data2,paramstr(3));
    rewrite(data2);
    x := 0;
    repeat
    x := 0;
    readln(data,tempstr);
    repeat
    IF (POS('`',tempstr) > x) then begin
       g := '';
       for q := 1 to (POS('`',tempstr)-1) do g := g + tempstr[q];
       f := '';
       for q := (POS('`',tempstr)+2) to length(tempstr) do f := f + tempstr[q];
       tempstr := g+f;
       x := LENGTH(g);
       end;
   until not (POS('`',tempstr ) > x);
   inc(d);
   writeln(data2,tempstr);
   until eof(data);
   close(data2);
  end;


procedure convert2rg;
 var data2:text;
     s,f,g,h:string;
     x,q,d:byte;
  begin
    IF paramstr(3) = '' then begin
       textcolor(15);
       writeln;
     writeln('Syntax:  LORDCONV <input> # <output>');
     writeln;
     writeln('     <input> - full path and filename of input file');
     writeln('               (ex. C:\LORD\LOGNOW.TXT)');
     writeln;
     writeln('           # - Color Output Option');
     writeln('               (1 - Renegade or Pipe-based system)');
     writeln('               (2 - ANsI)');
     writeln('               (3 - ASCII)');
     writeln('               (4 - Other - Read docs!)');
     writeln;
     writeln('    <output> - full path and filename of input file');
     writeln('               (ex. C:\BBS\BULLS\BULL1.ANS)');
     writeln;
     close(data);
     halt;
    end;
    assign(data2,paramstr(3));
    rewrite(data2);
    x := 0;
    repeat
    x := 0;
    tempstr := '';
    readln(data,tempstr);
    s := tempstr;
    tempstr := '';
    repeat
    IF (POS('`',s) > 0) then begin
      IF (s[pos('`',s)+1]) IN ['1','2','3','4','5','6','7','8','9','0','!','@','#','$','%','.'] then begin
       g := '';
       for q := 1 to (POS('`',s)-1) do g := g + s[q];
       CASE s[POS('`',s)+1] of
       '1':h := '|01';
       '2':h := '|02';
       '3':h := '|03';
       '4':h := '|04';
       '5':h := '|05';
       '6':h := '|06';
       '7':h := '|07';
       '8':h := '|08';
       '9':h := '|09';
       '0':h := '|10';
       '!':h := '|11';
       '@':h := '|12';
       '#':h := '|13';
       '$':h := '|14';
       '%':h := '|15';
       '.':h := '';
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       tempstr := tempstr+g+h;
       x := LENGTH(g);
       s := f;
       end
       else begin
       f := '';
       h := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       tempstr := tempstr+g+h;
       x := length(g);
       s := f;
       end;
      end;
   until (POS('`',s ) = 0);
   tempstr := tempstr + f;
   writeln(data2,tempstr);
   until eof(data);
   close(data2);
  end;




begin
  IF NOT FILEEXISTS(paramstr(1)) then begin
     textcolor(15);
     writeln;
     writeln('Syntax:  LORDCONV <input> # <output>');
     writeln;
     writeln('     <input> - full path and filename of input file');
     writeln('               (ex. C:\LORD\LOGNOW.TXT)');
     writeln;
     writeln('           # - Color Output Option');
     writeln('               (1 - Renegade or Pipe-based system)');
     writeln('               (2 - ANsI)');
     writeln('               (3 - ASCII)');
     writeln('               (4 - Other - Read docs!)');
     writeln;
     writeln('    <output> - full path and filename of input file');
     writeln('               (ex. C:\BBS\BULLS\BULL1.ANS)');
     writeln;
     halt;
  end;

  assign(data,paramstr(1));
  reset(data);
  val(paramstr(2),tempnum,errcode);
  CASE (tempnum) of
     1:convert2rg;
     2:convert2asc;
     3:convert2ans;
     4:convert2other;
  else begin
    textcolor(15);
    writeln;
     writeln('Syntax:  LORDCONV <input> # <output>');
     writeln;
     writeln('     <input> - full path and filename of input file');
     writeln('               (ex. C:\LORD\LOGNOW.TXT)');
     writeln;
     writeln('           # - Color Output Option');
     writeln('               (1 - Renegade or Pipe-based system)');
     writeln('               (2 - ANsI)');
     writeln('               (3 - ASCII)');
     writeln('               (4 - Other - Read docs!)');
     writeln;
     writeln('    <output> - full path and filename of input file');
     writeln('               (ex. C:\BBS\BULLS\BULL1.ANS)');
     writeln;
     close(data);
     halt;
  end;
  end;
  close(data);
  end.
